package alignment;


import java.io.*;
import java.util.HashMap;
import java.util.Vector;

import ontology.OntologyInstance;


/**
 * A class for the scoring scheme of a pairing of two ontology instances.
 */

public class PairingScorer implements Serializable
{
 HashMap <String, HashMap<String, Double>> _pairs_modificators;
 private static final long serialVersionUID = 1L;
 double _pairs_modificators_factor = 0.9;

 public PairingScorer ()
 {
  _pairs_modificators = new HashMap <String, HashMap<String, Double>> ();
  }

 public double score (String oi1, String oi2) { return - 11.0; }
 
 public double getValidatedHomologyScore () { return 0.0; }

 public void init (Vector <OntologyInstance> v1, Vector <OntologyInstance> v2) {}

 boolean isNumeric (String s)
 {
  try
     {
      Double d1 = new Double (s);
      d1.doubleValue ();
      return true;
      }
  catch (Exception e) {}
  return false;
  }

 public void decreasePairingScore (String working, String reference)
 {
  String [] words = working.split (" ");
  for (int i = 0; i < words.length; i++)
      {
       if (isNumeric (words [i]))
          {
           Double d = new Double (words [i]);
           words [i] = String.valueOf (d);
           }
       String [] words2 = reference.split (" ");
       for (int j = 0; j < words2.length; j++)
           {
            if (isNumeric (words2 [j]))
               {
                Double d = new Double (words2 [j]);
                words2 [j] = String.valueOf (d);
                }
            helpDecreasePairingScore (words [i], words2 [j]);
            }
       }
  }
 
 void helpDecreasePairingScore (String working, String reference)
 {
  //System.out.println ("Decreasing for " + working + " and " + reference);
  HashMap<String, Double> hm = _pairs_modificators.get (working);
  if (hm == null)
     {
      hm = new HashMap <String, Double> ();
      hm.put (reference, new Double (_pairs_modificators_factor));
      _pairs_modificators.put (working, hm);
      }
  else
     {
      Double d = hm.get (reference);
      if (d == null)
         {
          hm.put (reference, _pairs_modificators_factor);
          }
      else
         {
          hm.put (reference, new Double (d.doubleValue() * _pairs_modificators_factor));
          }
      }
  }
 }