package alignment;

import java.util.Vector;

import ontology.HomologyOntology;
import ontology.OntologyInstance;
import ontology.SpeciesOntology;

public class SimpleHomologyPropagator extends Propagator
{
 /**
  * 
  */
 private static final long serialVersionUID = 1L;

 HomologyMaker _maker;

 SimpleHomologyPropagator (HomologyMaker m)
 {
  _maker = m;  
  }

 /**
  * 
  * @param ao The <code>AnotatedOrgan</code> that contains the score to remove.
  * @param pos The position of <code>ao</code> in the <code>AnnotatedOrgan</code> list.
  * @param ps The <code>PairingScore</code> that represents the score to remove.
  */
 public void removePropagatedScore (AnnotatedOrgan ao, int pos, PairingScore ps)
 {
//  // Upper way:
//  Vector <String> parents_id = ao.getOrgan ().getObjectOfPropertyByPropertyIdAsVector (((SpeciesOntology) ao.getOrgan ().getOntology ()).getPartOfPropertyId ());
  OntologyInstance ref_candidate = ps.getOrganCandidate ();
//  Vector <String> ref_parents_id = ref_candidate.getObjectOfPropertyByPropertyIdAsVector (((SpeciesOntology) ref_candidate.getOntology ()).getPartOfPropertyId ());
//  if ((parents_id != null) && (ref_parents_id != null))
//  {
//   for (int i = 0; i < parents_id.size (); i++)
//       {
//        for (int j = 0; j < ref_parents_id.size (); j++)
//            {
//             OntologyInstance ref_parent = ps.getOrganCandidate ().getOntology ().getInstanceById ((String) ref_parents_id.get (j));
//             // Check if parent has ref_parent as a candidate:
//             AnnotatedOrgan ao_parent = _maker.getAnnotatedOrganByOrganId (parents_id.get (i));
//             PairingScore ps_parent = ao_parent.hasCandidate (ref_parent);
//             if (ps_parent != null)
//                ps_parent.addToReceivedScore (- ps.getScore ());
//             }
//       }
//  }

  // Down way:
  Vector <String> children_id = ao.getOrgan ().getObjectOfPropertyByPropertyIdAsVector ("inv_" + ((SpeciesOntology) ao.getOrgan ().getOntology ()).getPartOfPropertyId ());
  Vector <String> ref_children_id = ref_candidate.getObjectOfPropertyByPropertyIdAsVector ("inv_" + ((SpeciesOntology) ref_candidate.getOntology ()).getPartOfPropertyId ());
  if ((children_id != null) && (ref_children_id != null))
     {
      for (int i = 0; i < children_id.size (); i++)
          {
           Vector <PairingScore> group = new Vector <PairingScore> ();
           for (int j = 0; j < ref_children_id.size (); j++)
               {
                OntologyInstance ref_children = ps.getOrganCandidate ().getOntology ().getInstanceById ((String) ref_children_id.get (j));
                // Check if parent has ref_parent as a candidate:
                AnnotatedOrgan ao_child = _maker.getAnnotatedOrganByOrganId (children_id.get (i));
                PairingScore ps_children = ao_child.hasCandidate (ref_children);
                if (ps_children != null)
                   ps_children.cleanContributorToReceivedScore (ps.getInstance ().getId () + ps.getOrganCandidate ().getId ());                 
//                   ps_children.addToReceivedScore (- ps.getScore ());
                group.add (ps_children);
                }
           }
      }
  }

 /**
  * 
  * @param ao
  * @param ps
  * @param candidate
  */
 public void propagateForOrgan (AnnotatedOrgan ao, PairingScore ps, OntologyInstance candidate)
 {
 //System.out.println ("Propagating for " + ao.getName () + " (" + ao.getOrganId () + ") and " + candidate.getName () + " (" + candidate.getId () + ")");
//  // Upper way:
//  Vector <String> parents_id = ao.getOrgan ().getObjectOfPropertyByPropertyIdAsVector (((SpeciesOntology) ao.getOrgan ().getOntology ()).getPartOfPropertyId ());
  OntologyInstance ref_candidate = ps.getOrganCandidate ();
//  Vector <String> ref_parents_id = ref_candidate.getObjectOfPropertyByPropertyIdAsVector (((SpeciesOntology) ref_candidate.getOntology ()).getPartOfPropertyId ());
//  if ((parents_id != null) && (ref_parents_id != null))
//     {
//      // Iterate through the parents (working instance):
//      for (int i = 0; i < parents_id.size (); i++)
//          {
//           Vector <PairingScore> group = new Vector <PairingScore> ();
//           // Iterate through the parents of the reference instance:
//           AnnotatedOrgan ao_parent = _maker.getAnnotatedOrganByOrganId (parents_id.get (i));
//           for (int j = 0; j < ref_parents_id.size (); j++)
//               {
//                OntologyInstance ref_parent =
// ps.getOrganCandidate ().getOntology ().getInstanceById ((String) ref_parents_id.get (j));
//                
//                // Check if parent has ref_parent as a candidate:
//                PairingScore ps_parent = ao_parent.hasCandidate (ref_parent);
//                if ((ps_parent == null) && ao_parent.isValidChoice (ref_parent))
//                   {
//                    // ps_parent is not a candidate, and it is a valid choice, create a
//                    // new pairing:
//                    ps_parent = ao_parent.addCandidate (ref_parent);
//                    // Add the propagated score to the created PairingScore:
//                    if (ps_parent != null)
//                       {
//                        ps_parent.addToReceivedScore (ps.getScore ());
//                        group.add (ps_parent);
//                        }
//                    }
//                else
//                   if (ps_parent != null)
//                      {
//                       // There is already a pairing for these instances, add the score:
//                       ps_parent.addToReceivedScore (ps.getScore ());
//                       group.add (ps_parent);
//                       }
//                }
//           for (int j = 0; j < group.size (); j++)
//               group.get (j).setGroup (group);
//           }
//      }

  // Down way :
  Vector <String> children_id = ao.getOrgan ().getObjectOfPropertyByPropertyIdAsVector ("inv_" + ((SpeciesOntology) ao.getOrgan ().getOntology ()).getPartOfPropertyId ());
  Vector <String> ref_children_id = ref_candidate.getObjectOfPropertyByPropertyIdAsVector ("inv_" + ((SpeciesOntology) ref_candidate.getOntology ()).getPartOfPropertyId ());
  if ((children_id != null) && (ref_children_id != null))
     {
      for (int i = 0; i < children_id.size (); i++)
          {
           Vector <PairingScore> group = new Vector <PairingScore> ();
           AnnotatedOrgan ao_child = _maker.getAnnotatedOrganByOrganId (children_id.get (i));
           for (int j = 0; j < ref_children_id.size (); j++)
               {
                OntologyInstance ref_children = ps.getOrganCandidate ().getOntology ()
                                      .getInstanceById ((String) ref_children_id.get (j));

                //System.out.println ("Testing propagation for " + ao_child.getName () + " (" + ao_child.getOrganId () + ") and " + ref_children.getName () +" (" + ref_children.getId () + ")");

                PairingScore ps_children = ao_child.hasCandidate (ref_children);

                if ((ps_children == null) && checkPairValidity (ao_child, ref_children))
                   {
                    //System.out.println ("propagation accepted...");
                    ps_children = ao_child.addCandidate (ref_children);
                    // Add the propagated score to the created PairingScore:
                    ps_children.addToReceivedScore (ps.getScore (), ps.getInstance ().getId () + ps.getOrganCandidate ().getId ());
                    group.add (ps_children);
                   }
                else
                   if (ps_children != null)
                      {
                       //System.out.println ("Adding: " + ps.getScore ());
                       ps_children.addToReceivedScore (ps.getScore (), ps.getInstance ().getId () + ps.getOrganCandidate ().getId ());
                       group.add (ps_children);
                       }
                }
           for (int j = 0; j < group.size (); j++)
               group.get (j).setGroup (group);
           }
      }
  //System.out.println ("!!!! End of SimpleHomologyPropagator::propagateForOrgan");
  }

 /**
  * Checks various criteria before creating a new proposition.
  *  - The "different levels" problem: Say that two instances A have been validated; but
  *  they are at two different lvl in the hierarchies: x and x+1. If, at some point, the
  *  father of Ax is validated, we may have creation of new pairs for Ax. And these ones
  *  will be wrong: currently Ax+1 cannot be reach.
  *  To overcome this, be creating pairs for an instance that has homologs, we check if
  *  the candidates are in the same subtree than the homologs.
  * @param aoLeft
  * @param oiRight
  * @return
  */
 private boolean checkPairValidity (AnnotatedOrgan aoLeft, OntologyInstance oiRight)
 {
  // Check if oiRgiht has been discarded for aoLeft:
  if (! aoLeft.isValidChoice (oiRight))
     return false;

  // Check the "different levels" problem:
  HomologyOntology ho = (HomologyOntology) _maker.getHomologyOntology ();

  OntologyInstance hog_left = ho.getHomologyGroupOfOrgan (aoLeft.getOrgan ());
  OntologyInstance hog_right = ho.getHomologyGroupOfOrgan (oiRight);
  // Check if one of the instances have been paired:
  if ((hog_left == null) && (hog_right == null))
     return true;
  else
     {
	  // At least one of the instances have been paired.

      String p = ((SpeciesOntology) oiRight.getOntology ()).getPartOfPropertyId ();
      Vector <String> right_parents = oiRight.getObjectOfPropertyByPropertyIdAsVector (p);
      if (hog_left != null)
         {
          //System.err.println (aoLeft.getOrgan ().getId () + " already is in an homology group");
          // Check if one of the homolog of aoLeft is in the same subtree than oiRight:
          Vector <String> homologs = hog_left.getObjectOfPropertyByPropertyIdAsVector ("inv_" + ho.getPartOfPropertyId ());
          //System.err.println ("Homologs are: " + homologs);
          for (int i = 0; i < homologs.size (); i++)
              {
               String hid = homologs.get (i);
               // Check if hid is in the right ontology:
               OntologyInstance hoi = null;
               if ((hoi = oiRight.getOntology ().getInstanceById (hid)) != null)
                  {
            	   //System.err.println (hoi + " is in the right ontology");
                   for (int j = 0; j < right_parents.size (); j++)
                       {
                        boolean res = isSon (right_parents.get (j), hoi, "inv_" + p);
                        if (res) {
                                  //System.err.println ("Is a son, cancelling creation");
                                  return false; }
                        }
                   }
               }
          }

      Vector <String> left_parents = aoLeft.getOrgan ().getObjectOfPropertyByPropertyIdAsVector (p);
      if (hog_right != null)
         {
          //System.err.println (oiRight.getId () + " already is in an homology group");

          // Check if one of the homolog of oiright is in the same subtree than aoLeft:
          Vector <String> right_homologs = hog_right.getObjectOfPropertyByPropertyIdAsVector ("inv_" + ho.getPartOfPropertyId ());
          //System.err.println ("Homologs are: " + right_homologs);
          for (int i = 0; i < right_homologs.size (); i++)
              {
               String hid = right_homologs.get (i);
               // Check if hid is in the right ontology:
               OntologyInstance hoi = null;
               if ((hoi = aoLeft.getOrgan ().getOntology ().getInstanceById (hid)) != null)
                  {
            	   //System.err.println (hoi + " is in the left ontology");
                   for (int j = 0; j < left_parents.size (); j++)
                       {
                        boolean res = isSon (left_parents.get (j), hoi, "inv_" + p);
                        if (res) {
                         //System.err.println ("Is is a son, cancelling creation");
                         return false; }
                        }
                   }
               }
          }
      }
  return true;
  }

 /**
  * Check if <code>oi</code> is in the subtree that has <code>root</code> as a root.
  * @param root
  * @param oi
  * @param p
  * @return <code>true</code> if oi is a descendant of root, <code>false</code> otherwise.
  */
 boolean isSon (String root, OntologyInstance oi, String p)
 {
  //System.err.println ("SimpleHomologyPropagator::isSon\n=>begin");
  //System.err.println ("Checking if " + oi.getId () + " is a son of " + root + " by property " + p);
  OntologyInstance oiRoot = oi.getOntology ().getInstanceById (root) ;
  if (oiRoot == null)
     {
	  //System.err.println ("Error, both instances are not in the same ontology");
	  return false;
      }
  //System.err.println ("SimpleHomologyPropagator::isSon\n=>end");
  Vector <String> rootSons = oiRoot.getObjectOfPropertyByPropertyIdAsVector (p);
  if (rootSons == null)
     {
      //System.err.println ("Error, " + root + " has no son");
      return false;
      }
  for (int i = 0; i < rootSons.size (); i++)
	  if (oi.getId ().equals(rootSons.get (i)))
		 return true;
      else
         {
    	  if (helpIsSon (oi.getOntology ().getInstanceById (rootSons.get (i)), oi, p))
    		 return true;
          }
  return false;
  }

 boolean helpIsSon (OntologyInstance oiRoot, OntologyInstance oi, String p)
 {
  Vector <String> rootSons = oiRoot.getObjectOfPropertyByPropertyIdAsVector (p);
  if (rootSons != null)
     {
	  for (int i = 0; i < rootSons.size (); i++)
		  if (oi.getId ().equals(rootSons.get (i)))
			 return true;
	      else
	         {
	    	  if (helpIsSon (oi.getOntology ().getInstanceById (rootSons.get (i)), oi, p))
	    		 return true;
	          }
      }
  return false;
  }
 }
