package datalayer;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Vector;

import ontology.HomologyOntology;

public class OboHomologyReader
{
 String _filename;
 BufferedReader _handle;
 HomologyOntology _ho;

 public OboHomologyReader (String f) throws IOException
 {
  //System.err.println ("Opening: " + f);
  _filename = f;
  try {
       _handle = new BufferedReader (new FileReader (new File (_filename)));
       read_header ();
          }
     catch (FileNotFoundException e)
     {
      e.printStackTrace();
      }

 try {
      _handle = new BufferedReader (new FileReader (new File (_filename)));
      _ho = new HomologyOntology (_filename);
      _ho.setBaseURI (f);
      read_header ();
      // read the new relation definition:
      String str;
      while (! (str = _handle.readLine ()).equals (""))
            {
	     // Read the type of the current token:
	     if (! str.equals ("[Typedef]"))
	        {
		 // This error message is wrongly placed
		 //System.err.println ("Error the term to be read should be a Typedef, got '" + str + "' instead");
	         }
	     // The remaining lines are ignored for now.
            }
      // read the terms (homology groups):
      while ((str = _handle.readLine ()) != null)
            {
             // The current token should be a Term
             if (! str.equals ("[Term]"))
                {}
             else
                {
                 String id = _handle.readLine ();
                 String [] words = id.split (": ");
                 id = words [1];
                 System.err.println ("id: " + id);
                 // read the "name" lines:
                 Vector <String> names = new Vector <String> ();
                 str = _handle.readLine ();
                 words = str.split ("name: ");
                 while (words.length > 1)
                       {
                        names.add (words [1]);
                        str = _handle.readLine ();
                        words = str.split ("name: ");
                        }
                 Vector <String> members = new Vector <String> ();
                 // Current str should contain a "relationship"
                 words = str.split ("has_member ");
                 members.add (words [1]);
                 // Read the other relationship lines:
                 while (! (str = _handle.readLine ()).equals (""))
                       {
                        words = str.split ("has_member ");
                        members.add (words [1]);
                        }
                 // Add the current instance to the ontology:
                 _ho.addInstanceFromRawData (id, names, members);
                 }
             }
      }
 catch (Exception e)
       {
        e.printStackTrace();
        }
 }

 private void read_header ()
 {
  String str;
  try {
       while (! (str = _handle.readLine ()).equals (""))
            {
             //System.err.println (str);
             }
      }
  catch (IOException e) { e.printStackTrace(); }
  }

 // Getters:
 public HomologyOntology getOntology () { return _ho; }
 }
