package datalayer;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

import ontology.HomologyOntology;

/**
 * Save an homology ontology in a file, using the OWL format.
 * Some assumptions are made, especially to simplify the readeing part in
 * <code>OwlReader</code>.
 * 
 * @author admin
 */
public class OwlWriter
{
 /**
  * The homology ontology that will be written on disk.
  */
 HomologyOntology _o;

 /**
  * The <code>BufferedWriter</code> used to write the homology ontology.
  */
 BufferedWriter _bw;

/**
 * @param f
 * @param o
 */
 public OwlWriter (String f, HomologyOntology o)
 {
  try
  {
   FileWriter file = new FileWriter (new File (f));
   _bw = new BufferedWriter (file);

   writeHeader ();
   }
  catch (Exception e) {}
  }

 /**
  * 
  */
 private void writeHeader () throws Exception
 {
  _bw.write ("?xml version=\"1.0\"?");
  _bw.newLine ();
  }
 }
