package datalayer;

import java.io.File;
import java.io.IOException;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class WorkspaceReader
{
 private String _homology_ontology_filename = null;
 private String _discards_filename = null;
 private String _annotations_filename = null;
 private Vector <String> _species_filename;
 String _base_dir;

 public WorkspaceReader (String f)
 {
  _species_filename = new Vector <String> ();
  _base_dir = f;
  try
      {
       // cration d'une fabrique de documents
       DocumentBuilderFactory fabrique = DocumentBuilderFactory.newInstance ();

       // cration d'un constructeur de documents
       DocumentBuilder constructeur = fabrique.newDocumentBuilder ();

       // lecture du contenu d'un fichier XML avec DOM
       System.err.println ("Opening: " + f + File.separator + "data.xml");
       File xml = new File (f + File.separator + "data.xml");
       Document document = constructeur.parse (xml);
       NodeList ho = document.getElementsByTagName ("homology_ontology");
       if (ho.getLength () > 1) { System.err.println ("Warning, too many homology ontology listed, opening the first one, others will be ignored."); }
       if (ho.getLength () > 0)
          {
           Element e = (Element) ho.item (0);
           if (e.hasAttribute ("uri"))
              { _homology_ontology_filename = e.getAttribute ("uri"); }
           else
              { System.err.println ("Error, no uri for the homology ontology."); }
           }

       NodeList so = document.getElementsByTagName ("species");
       for (int i = 0; i < so.getLength (); i++)
           _species_filename.add (((Element) so.item (i)).getAttribute ("uri"));
       }
  catch (ParserConfigurationException pce)
        {
         System.out.println("Erreur de configuration du parseur DOM");
         System.out.println("lors de l'appel  fabrique.newDocumentBuilder();");
         }
  catch (SAXException se)
        {
         System.out.println("Erreur lors du parsing du document");
         System.out.println("lors de l'appel  construteur.parse(xml)");
         }
  catch (IOException ioe)
        {
         System.out.println("Erreur d'entre/sortie");
         System.out.println("lors de l'appel  construteur.parse(xml)");
         }
  }

 // Getters:
 public String getHomologyOntologyFilename () { return _homology_ontology_filename; }

 public Vector <String> getSpeciesFilename () { return _species_filename; }
 
 public String getDiscardsFilename () { return _discards_filename; }

 public String getAnnotationsFilename () { return _annotations_filename; }

 public String getBaseDirectory () { return _base_dir; }
 }
