package ontology;

import java.io.*;

/**
 * This class defines some common properties to the obo like "ontologies".
 *
 * @author Gilles Parmentier
 */
public abstract class OboOntology extends Ontology implements Serializable
{
 /**
  * The id of the "part of" property.
  */
 String _poId;
 String _poName;
 OntologyProperty _opPartOf;

 private static final long serialVersionUID = 1L;

 OboOntology (String name)
 {
  super (name);
  _poId = "PartOf";
  _poName = "part_of";
  }

 public abstract void setupPartOfProperty (String subjectClassId, String objectClassId);

 public String getPartOfPropertyId () { return _poId; }
 }