package ontology;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.Vector;
import java.util.Map.Entry;

import datalayer.OboReader;

public class OntologyFactory
{
 public OboOntology getOboOntology (String file)
 {
  OboOntology o = new SpeciesOntology (file, - 1);
  o.setBaseURI (file);

  OboReader or = new OboReader (file);
  Hashtable <String, Hashtable <String, String>> triplets = or.getTriplets ();
  Set <Entry <String, Hashtable <String, String>>> s = triplets.entrySet ();
  Iterator <Entry <String, Hashtable <String, String>>> it = s.iterator ();
  Hashtable <String, Vector <String>> desc = or.getCompleteDescritions ();

  // Stores OntologyInstance to facilitate the adding of properties:
  Hashtable <String, OntologyInstance> ois = new Hashtable <String, OntologyInstance> ();

  String org_clss = "Organ";
  while (it.hasNext ())
        {
         Map.Entry <String, Hashtable <String, String>> entree = it.next ();
         System.out.println(entree.getKey() + " " + entree.getValue());
         Hashtable <String, String> elem = (Hashtable <String, String>) entree.getValue ();
         // We don't want development stages here, so we have to check the is_a
         // relationship.
         String is_a = elem.get ("is_a");
         //System.out.println ("is_a: " + is_a);
         if (is_a != null)
            {
             Hashtable <String, String> is_a_elem = triplets.get (is_a);
             if (is_a_elem == null)
            	 System.err.println ("NO ELEMENT FOUND FOR: " + is_a);
             //System.out.println(is_a_elem.get ("id") + " " + is_a_elem.get("name"));
             if (! is_a_elem.get ("name").equals ("Stages"))
                {
                 //System.out.println (elem.get ("name"));
                 //System.out.println ("is a:" + is_a + "; " + is_a_elem.get ("name"));

        	 // Check for synonyms
                  int nb_syn = 1;
        	 Vector <String> synonyms = new Vector <String> ();
        	 while (elem.get ("synonym:" + nb_syn) != null)
        	       {
        	        synonyms.add (elem.get ("synonym:" + nb_syn));
        	        nb_syn++;
        	        }
                 OntologyInstance oi = new OntologyInstance (o, elem.get ("name"), elem.get ("id"), org_clss, synonyms, desc.get (elem.get ("id")));
                 o.addInstance (oi);
                 ois.put (elem.get ("id"), oi);
                 }
             }
         else
            {
             int nb_syn = 1;
    	     Vector <String> synonyms = new Vector <String> ();
             while (elem.get ("synonym:" + nb_syn) != null)
    	           {
    	            synonyms.add (elem.get ("synonym:" + nb_syn));
    	            nb_syn++;
    	            }
             OntologyInstance oi = new OntologyInstance (o, elem.get ("name"), elem.get ("id"), org_clss, synonyms, desc.get (elem.get ("id")));
             //System.out.println ("Adding: " + elem.get ("id") + "; " + elem.get ("name"));
             o.addInstance (oi);
             ois.put (elem.get ("id"), oi);
             }
         }

  //System.out.println (ois.size () + " OntologyInstance");

  // Build the inverse property of PartOf:
  String prop = "PartOf";
  OntologyProperty iop = o.addInverseProperty  (prop);
  iop.setInverse ();
  String inv_id = iop.getId ();
  it = s.iterator ();
  // Add the part_of relationship. Currently the is_a property is merged with the part_of
  // property, thus we add both properties as part_of.
  while (it.hasNext ())
        {
         Map.Entry <String, Hashtable <String, String>> entree = it.next ();
         Hashtable <String, String> elem = (Hashtable <String, String>) entree.getValue ();
         OntologyInstance subject = ois.get (elem.get ("id"));
         String is_a = elem.get ("is_a");
         if (is_a != null)
            if (triplets.get (is_a).get ("name").equals ("Stages"))
               {
                // Development stage; nothing to do.
                }
            else
               {
                // is_a relation, but not related to a development stage qualification. We add it as a part_of relation:
                OntologyInstance object = ois.get (elem.get ("is_a"));
                if (subject == null) System.err.println ("Subject is null !!!");
                if (object == null) System.err.println ("Object is null !!!");
                //System.out.println ("Adding " + subject.getName () + " has part_of " + object.getName ());
                subject.addProperty (prop, object.getId ());
                object.addProperty (inv_id, subject.getId ());
                // Now look for a part_of relation:
                String part_of = elem.get ("part_of");
                if (part_of != null)
                   {
                    OntologyInstance object2 = ois.get (elem.get ("part_of"));
                    //System.out.println ("Adding " + subject.getName () + " has part_of " + object2.getName ());
                    subject.addProperty (prop, object2.getId ());
                    object2.addProperty (inv_id, subject.getId ());
                    }
                }
         else
            {
 // is_a was not present, look for a part_of:
        	 String part_of = elem.get ("part_of");
        	 if (part_of != null)
        	 {
  OntologyInstance object2 = ois.get (elem.get ("part_of"));
  if (object2 == null)
  {
   System.err.println ("Warning: " + subject.getId () + " is part_of " + elem.get ("part_of") + " that does not exists");
   }
  else
  {
   //System.out.println ("Adding " + subject.getName () + " has part_of " + object2.getName ());
   subject.addProperty (prop, object2.getId ());
   object2.addProperty (inv_id, subject.getId ());
  }
  }
  }
         }
  return o;
  }
 }
