package ontology;

import java.io.*;
import java.util.Vector;

public class SpeciesOntology extends OboOntology implements Serializable
{
 protected int _species_id;

 private static final long serialVersionUID = 1L;

 public SpeciesOntology (String n, int id)
 {
  super (n);
  _species_id = id;

  OntologyClass ocOrgan = new OntologyClass ("Organ", "Organ");
  addClass (ocOrgan);
  setupPartOfProperty ("Organ", "Organ");
  addProperty (_opPartOf);
  }

/**
 * Debugging function, displays the ontology as a text tree.
 */
 public void display ()
 {
  System.out.println ("*** Tree view of the ontology***");
  for (int i = 0; i < _instances.size (); i++)
      {
       OntologyInstance oi = (OntologyInstance) _instances.get (i);
       Vector <String> parents = oi.getObjectOfPropertyByPropertyIdAsVector (getPartOfPropertyId ());
       if (parents == null)
          oi.displayAsTreeText ("");
       }
  System.out.println ("*** End ***");
  }

 public void setupPartOfProperty (String subjectClassId, String objectClassId)
 {
  _opPartOf = new OntologyProperty (_poName, _poId, subjectClassId, objectClassId);
  }
 }