package visualization;

import alignment.AnnotatedOrgan;

/**
 * This class displays the information contained in an <code>AnnotatedOrgan</code>, as an
 * HTML <code>String</code>.
 * Note: It displays only the informations specific to an <code>AnnotatedOrgan<code>, as we
 * already have such tools for the ontology objects.
 *
 * @see <code>OntologyClassView</code>, <code>OntologyInstanceView</code>,
 *      <code>OntologyObjectView</code>, <code>OntologyPropertyView</code>
 */
class AnnotatedOrganView
{
 AnnotatedOrgan _ao;
 String _display;

 public AnnotatedOrganView (AnnotatedOrgan ao)
 {
  _ao = ao;
  _display = "";
  }

 /**
  * Returns an HTML <code>String<code> representation of the informations stored in an
  * <code>AnnotatatedOrgan</code>. If the <code>String</code> does not exist yet, it is
  * build.
  *
  *@return An HTML <code>String</code> representation of an <code>AnnotatedOrgan</code>.
  */
 public String display ()
 {
  // Ici j'affiche des choses comme le nombre de choix trouves.
  if (_display.equals (""))
     {
      _display = "<h2>Number of homologs: " + _ao.getNbHomologs () + "</h2><br>";
      _display += "<h2>Number of propositions: " + _ao.getNbAppariements () + "</h2>";
      }
  return _display;
  }
 }