package visualization;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

import alignment.AnnotatedOrgan;

/**
 * This class displays the results of an iteration of the alignment algorithm. The user
 * is asked to validated the proposed homologies. After this, a new iteration of the
 * algorithm should occure.
 */
class DisplayPropositions extends JDialog implements ActionListener
{
 /**
  * 
  */
 private static final long serialVersionUID = 1L;
 Vector <AnnotatedOrgan> _propositions;
 JPanel _pane;
 AnnotatedOrganDisplayer [] _aod;
 boolean _validated;

 JButton jbEnter, jbCancel;

 private static String btnStrEnter = "Enter";
 private static String btnStrCancel = "Cancel";

 public DisplayPropositions (Frame f)
 {
  super (f, true);
  _pane = new JPanel (new GridLayout (0, 1));

  JPanel complete = new JPanel (new BorderLayout ());
  complete.add (_pane, BorderLayout.CENTER);

  JPanel buttonPane = new JPanel (new FlowLayout ());
  jbEnter = new JButton (btnStrEnter);
  jbEnter.addActionListener (this);
  jbCancel = new JButton (btnStrCancel);
  jbCancel.addActionListener (this);
  buttonPane.add (jbEnter);
  buttonPane.add (jbCancel);
  complete.add (buttonPane, BorderLayout.PAGE_END);

  setContentPane (complete);
  _validated = false;
  }

 public void display (Vector <AnnotatedOrgan> v)
 {
  _propositions = v;
  _aod = new AnnotatedOrganDisplayer [v.size ()];
  for (int i = 0; i < v.size (); i++)
      {
       _aod [i] = new AnnotatedOrganDisplayer ((AnnotatedOrgan) v.get (i));
       _pane.add (_aod [i]);
       }
  pack ();
  setVisible (true);
  }

 public Vector<Integer> getChoices ()
 {
  Vector<Integer> res = new Vector<Integer> ();
  for (int i = 0; i < _aod.length; i++)
      res.add (_aod [i].getStatus ());
  return res; 
  }

 public void actionPerformed(ActionEvent e)
 {
  if (e.getActionCommand ().equals ("Enter"))
     {
      _validated = true;
      setVisible (false);
      }
  else
     if (e.getActionCommand ().equals ("Cancel"))
        {
         clearAndHide ();
         }
  }

 public boolean isValidated () { return _validated; }

 private void clearAndHide ()
 {
  _propositions = null;
  _aod = null;
  _validated = false;
  setVisible (false);
  }
 }