package visualization;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class FindOrphanWindow extends JDialog implements ActionListener
{
 JComboBox _onto_choice;	
 JButton _jbOk, _jbCancel, _jbNext;
 Main _m;

  /**
   *
   */
  private static final long serialVersionUID = 1L;

  public FindOrphanWindow (JFrame f, Main m)
    {
     super (f);

     _m = m;
     JPanel middle = new JPanel (new GridLayout (2, 2));
     JLabel jl = new JLabel ("Select ontology: ");
     middle.add (jl);
     _onto_choice = new JComboBox ();
     middle.add (_onto_choice);
     this.getContentPane ().add (middle, BorderLayout.CENTER);

     JPanel jpButtons = new JPanel (new FlowLayout ());
     _jbOk = new JButton ("Ok");
     _jbOk.addActionListener (this);
     getRootPane().setDefaultButton(_jbOk);
     jpButtons.add (_jbOk);
    
     _jbNext = new JButton ("Next");
     _jbNext.addActionListener (this);
     _jbNext.setEnabled (false);
     jpButtons.add (_jbNext);
     
     _jbCancel = new JButton ("Cancel");
     _jbCancel.addActionListener (this);
     jpButtons.add (_jbCancel);

     this.getContentPane ().add (jpButtons, BorderLayout.PAGE_END);

     pack ();
     setVisible (false);
     }
    
    public void actionPerformed(ActionEvent e)
    {
     if (e.getActionCommand ().equals ("Cancel"))
        {
         setVisible (false);
         dispose ();
         }
     else
        if (e.getActionCommand ().equals ("Ok"))
           {
            String choice = (String) _onto_choice.getSelectedItem ();
            _m.searchOrphanInOntologies (choice);
            }
        else
           if (e.getActionCommand ().equals ("Next"))
              _m.iterateSearchOrphanInOntologies((String) _onto_choice.getSelectedItem ());
     }

    public void activateNext ()
    { _jbNext.setEnabled (true);
    getRootPane().setDefaultButton(_jbNext); }

    //Setters:
    public void setChoices (Vector <String> choices)
    {
     //_onto_choice.addItem ("both");
     // Avant d'ajouter le nom il faut verifier s'il y est deja ou pas ...
     for (int i = 0; i < choices.size (); i++)
     {
   boolean already_in = false;
   for (int j = 0; j < _onto_choice.getItemCount (); j++)
   if (choices.get(i).equals((String) _onto_choice.getItemAt (j)))
   {
   already_in = true;
   break;
   }
   if (! already_in)
     _onto_choice.addItem (choices.get(i));
     }
     }
 }
