package visualization;



import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Vector;
//import java.util.List;
//import java.util.Vector;

import javax.swing.JComponent;
//import javax.swing.JMenuItem;
//import javax.swing.JPopupMenu;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

import ontology.Ontology;
import ontology.OntologyInstance;





/**
 * This class stores the tree view of an ontology. This view is an extension of the class
 * <code>JTree</code>.
 *
 * @author Gilles Parmentier
 */
class OntologyTreeView extends JTree implements ActionListener
{
 /**
  *
  */
 private static final long serialVersionUID = 1L;
 @SuppressWarnings("unused") private Ontology _ontology;
// private JPopupMenu _tree_popup_menu;
 @SuppressWarnings("unused")
 private DefaultMutableTreeNode _root, _selectedNode;
 private DefaultTreeModel _treeModel;
 Vector<TreeNode> _findResults;
 int _pos_in_results;

 OntologyTreeView (Main parent, DefaultTreeCellRenderer renderer, DefaultTreeModel tm, Ontology o, DefaultMutableTreeNode r)
 {
  super (tm);
  _treeModel = tm;
  getSelectionModel ().setSelectionMode (TreeSelectionModel.SINGLE_TREE_SELECTION);
  addTreeSelectionListener ((TreeSelectionListener) parent);
  _root = r;
  _ontology = o;
  if (renderer != null) setCellRenderer (renderer);
  setRootVisible (false);

  PopupListener pl = new PopupListener (this);
  this.addMouseListener (pl);
  makePopupMenu ();
  }

 boolean hasTree (JTree t) { return ((JTree) this).equals (t); }

 /**
  * Responds to the contextual popup menu actions.
  */
 public void actionPerformed (ActionEvent e)
 {
 // JMenuItem source = (JMenuItem) e.getSource ();
  //if (source.getText ().equals ("Delete node"))
  //   this.deleteNode ();
  //else
  //   if (source.getText ().equals ("Edit node"))
  //      this.editNode ();
  }

 /**
  * Looks for a String in the ontology. Currently the checked data are the name and the id
  * of instances.
  */
 public Vector<TreeNode> find (String text)
 {
  Vector<TreeNode> res = new Vector<TreeNode> ();

  // Il faut que je parcours tous les TreeNode et que je regarde si l'objet qu'il contient a pour name quelque chose qui approche de ce que je cherche.
  for (int i = 0; i < _root.getChildCount () ; i++)
      {
       DefaultMutableTreeNode current_node = (DefaultMutableTreeNode) _root.getChildAt (i);
       OntologyObjectView oov = (OntologyObjectView) (current_node.getUserObject ());
       // /!\ Ici je fais deliberement le choix de ne faire qu'une recherche sur l'id, et avec une egalite stricte... Le but n'est pas d'avoir quelque chode de completement fonctionnel, mais juste d'avoir un outil m'aidant au debuggage.
       if (oov.getObject ().getClass ().getName ().equals ("OntologyInstance"))
          if ((oov.getObject ().getId ().toLowerCase ().equals (text.toLowerCase ())) || (((OntologyInstance) oov.getObject ()).getName ().toLowerCase ().contains (text.toLowerCase ())))
             {
              // Rien a faire a part selectionner le noeud.
              res.add (current_node);
              }
       Vector<TreeNode> tmp_res = recursive_find (current_node, text);
       for (int j = 0; j < tmp_res.size (); j++)
           res.add (tmp_res.get (j));
       }
  if (res.size () >= 1)
     {
      TreeNode [] tna = _treeModel.getPathToRoot (res.get(0));
      TreePath tp = new TreePath (tna);
      setSelectionPath (tp);
      scrollPathToVisible (tp);
      }
  _findResults = res;
  _pos_in_results = 0;
  return res;
  }

 public Vector<TreeNode> findOrphan ()
 {
  Vector <TreeNode> res = new Vector <TreeNode> ();
  for (int i = 0; i < _root.getChildCount (); i++)
      {
       
       }
  return res;
  }

 private Vector<TreeNode> recursive_find (DefaultMutableTreeNode node, String text)
 {
  Vector<TreeNode> res = new Vector<TreeNode> ();

  for (int i = 0; (i < node.getChildCount ()) ; i++)
      {
      DefaultMutableTreeNode current_node = (DefaultMutableTreeNode) node.getChildAt (i);
       OntologyObjectView oov = (OntologyObjectView) current_node.getUserObject ();
       if ((oov.getObject ().getId ().toLowerCase ().equals (text.toLowerCase ())) || (((OntologyInstance) oov.getObject ()).getName ().toLowerCase ().contains (text.toLowerCase ())))
          {
           // Rien a faire a part selectionner le noeud.
           res.add (current_node);
           }
       Vector<TreeNode> tmp_res = recursive_find (current_node, text);
       for (int j = 0; j < tmp_res.size (); j++)
           res.add (tmp_res.get (j));
       }
  
  return res;
  }

 public void iterateFind ()
 {
  _pos_in_results++;
  if (_pos_in_results == _findResults.size ()) _pos_in_results = 0;
  TreeNode [] tna = _treeModel.getPathToRoot (_findResults.get(_pos_in_results));
  TreePath tp = new TreePath (tna);
  setSelectionPath (tp);
  scrollPathToVisible (tp);
  }

 private void makePopupMenu ()
 {
  }

 private void displayPopup (int X, int Y)
 {
  }

 class PopupListener extends MouseAdapter
 {
  @SuppressWarnings("unused")
private JComponent _parent;

  public PopupListener (JComponent p) { super (); _parent = p; }

  public void MousePressed (MouseEvent e)
  { if (e.isPopupTrigger ()) displayPopup (e.getX (), e.getY ()); }
  }
 };